aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorOmar Sandoval <osandov@fb.com>2018-05-09 23:21:55 -0700
committerEryu Guan <guaneryu@gmail.com>2018-05-16 09:53:15 +0800
commit5c19a58f7d99567e2e664558f32fbacb11b169d3 (patch)
treeeb67534139e8cbdb62bd85e768f4c36007400803
parenta82e9464ddfb3ed677e0080301adbab3dab47546 (diff)
downloadxfstests-dev-5c19a58f7d99567e2e664558f32fbacb11b169d3.tar.gz
btrfs: test ENOSPC caused by many orphan items
Btrfs has a bug where we can prematurely ENOSPC if we have lots of orphaned files, i.e., deleted files which are still open. Add a test which repeatedly creates and deletes a file while keeping all of the file descriptors open. This should succeed but doesn't on Btrfs without the fix. [Eryu: use multi_open_unlink command to keep files open & unlinked instead of shell scripts] Signed-off-by: Omar Sandoval <osandov@fb.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rwxr-xr-x[-rw-r--r--]tests/generic/4790
-rwxr-xr-xtests/generic/48862
-rw-r--r--tests/generic/488.out2
-rw-r--r--tests/generic/group1
4 files changed, 65 insertions, 0 deletions
diff --git a/tests/generic/479 b/tests/generic/479
index 7e4ba7d046..7e4ba7d046 100644..100755
--- a/tests/generic/479
+++ b/tests/generic/479
diff --git a/tests/generic/488 b/tests/generic/488
new file mode 100755
index 0000000000..225fbb4082
--- /dev/null
+++ b/tests/generic/488
@@ -0,0 +1,62 @@
+#! /bin/bash
+# FS QA Test 488
+#
+# Test having many file descriptors referring to deleted files open. Regression
+# test for patch "Btrfs: fix ENOSPC caused by orphan items reservations".
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2018 Omar Sandoval. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+. ./common/rc
+. ./common/filter
+
+rm -f $seqres.full
+
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_test_program "multi_open_unlink"
+
+_scratch_mkfs_sized $((1024 * 1024 * 1024)) >> $seqres.full 2>&1
+_scratch_mount
+
+test_file="$SCRATCH_MNT/$seq"
+
+ulimit -n $((16 * 1024))
+# ~10000 files on a 1 GB filesystem should be no problem.
+$here/src/multi_open_unlink -f $SCRATCH_MNT/$seq -n 10000 -s 0
+
+echo "Silence is golden"
+
+status=0
+exit
diff --git a/tests/generic/488.out b/tests/generic/488.out
new file mode 100644
index 0000000000..07c40c4a14
--- /dev/null
+++ b/tests/generic/488.out
@@ -0,0 +1,2 @@
+QA output created by 488
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index dc637c96c2..6266213e37 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -490,3 +490,4 @@
485 auto quick insert
486 auto quick attr
487 auto quick
+488 auto quick